﻿/**

*/
module nemuxi.utility.convert.item;

debug import std.stdio: wl = writefln, pl = printf;

import std.contracts;

import nemuxi.base;
import nemuxi.file.file;
import nemuxi.file.items.item;
public import nemuxi.utility.convert.convert;
import nemuxi.utility.filter.item;


Text IdFromFileAddress(in Text Address)
out(r) {
	assert(Item.isID(r.toString));
}
body {
	enforce(Address.length, new ConvertException("ファイルアドレス未入力"));

	Text SafeName;
	auto FileName = PATH.getName(Address);
	if(FileName.length) {
		// ファイル？
		if(Item.isID(FileName.toString)) {
			SafeName = FileName;
		} else {
			SafeName = SafeId(FileName);
		}
	} else {
		// ファイルアドレス以外
		SafeName = SafeId(Address);
	}
	enforce(SafeName.length, new ConvertException("変換文字列長不正"));

	return SafeName;
}

